PLM之家 UG NX10.0二次开发(ufun和NXOpen C++)网络培训火热报名

PLM之家-上海点团信息科技有限公司工业4.0数字化软件官方知识管理平台

查看: 13790|回复: 132

[原创视频] PLM之家-NX9.0 二次开发实例视频-24 创建自定义基准CSYS

  [复制链接]
  • TA的每日心情

    2017-5-26 12:10
  • 签到天数: 9 天

    [LV.3]偶尔看看II

    301

    主题

    610

    帖子

    7000

    积分

    管理员

    PLM之家NX|TC专家

    Rank: 9Rank: 9Rank: 9

    积分
    7000
    发表于 2013-12-2 20:43:43 | 显示全部楼层 |阅读模式
    PLM之家-NX9.0 二次开发实例视频-24 创建自定义基准CSYS


    内容:
    创建自定义基准CSYS控件使用,熟悉使用CSYS控件,熟悉使用NX Open C++进行对象的颜色修改。
    目的:
    使用CSYS控件可以获得一个基准坐标,对应基准坐标需要使用坐标创建才能得到,要想对基准坐标进行颜色的修改,需要对基准的所有自对象进行修改。



    24 创建自定义基准CSYS

    24 创建自定义基准CSYS




    1. try
    2.     {
    3.         //---- Enter your callback code here -----

    4.                      NXOpen::ListingWindow  *lw = theSession->ListingWindow();
    5.                          stringstream ss;
    6.                         NXOpen::Vector3d xdir,ydir;
    7.                         NXOpen::Point3d originPoint;
    8.                         lw->Open();
    9.                         ss << ("创建的坐标系统信息如下:\n");
    10.             std::vector<NXOpen::TaggedObject *> coordObjects = this->coord_system0->GetProperties()->GetTaggedObjectVector("SelectedObjects");
    11.                         NXOpen::CartesianCoordinateSystem *coord = dynamic_cast<NXOpen::CartesianCoordinateSystem *>(coordObjects[0]);
    12.                coord->GetDirections(&xdir,&ydir);
    13.                         ss<<"返回的坐标系X方向矢量是:"<<xdir.X<<"\t"<<xdir.Y<<"\t"<<xdir.Z<<endl;
    14.                         ss<<"返回的坐标系Y方向矢量是:"<<ydir.X<<"\t"<<ydir.Y<<"\t"<<ydir.Z<<endl;
    15.                         originPoint = coord->Origin();
    16.                         ss<<"返回的坐标系中心是:"<<originPoint.X<<"\t"<<originPoint.Y<<"\t"<<originPoint.Z<<endl;
    17.                         lw->WriteLine(ss.str());
    18.                   // create the csys
    19.                         Part *workpart(theSession->Parts()->Work());
    20.                         Features::Feature *null_feature(NULL);
    21.                         Features::DatumCsysBuilder *datumCsysBuilder ;
    22.                         datumCsysBuilder = workpart->Features()->CreateDatumCsysBuilder(null_feature);
    23.                         datumCsysBuilder->SeTCsys(coord);
    24.                         //set the scale factor
    25.                         datumCsysBuilder->SetDisplayScaleFactor(this->double0->GetProperties()->GetDouble("Value"));
    26.                         datumCsysBuilder->Commit();
    27.                         std::vector< NXOpen::NXObject * >  GetCommittedObjects;
    28.                         GetCommittedObjects=datumCsysBuilder->GetCommittedObjects();
    29.                         datumCsysBuilder->Destroy();
    30.                         // set the color
    31.                     NXOpen::DisplayModification *displayObject;
    32.                         displayObject = theSession->DisplayManager()->NewDisplayModification();
    33.                         displayObject->SetApplyToAllFaces(true);

    34.                         // get the color from the UI
    35.                         std::vector<int> color = this->colorPicker0->GetProperties()->GetIntegerVector("Value");
    36.                         displayObject->SetNewColor(color[0]);

    37.                         std::vector <DisplayableObject *> csysObject;
    38.                         ss.clear();
    39.                         ss.str("");
    40.                         ss<<"一个坐标系生成的对象有几个:"<< GetCommittedObjects.size()<<endl;
    41.                         lw->WriteLine(ss.str());
    42.                         for(unsigned int i = 0 ; i < GetCommittedObjects.size();i ++ )
    43.                         {
    44.                                 csysObject.push_back(        dynamic_cast<DisplayableObject *>(GetCommittedObjects[i]));
    45.                         }
    46.                         displayObject->Apply(csysObject);
    47.                         delete displayObject;
    48.     }
    复制代码






    PLM之家,专业的NX,Teamcenter学习视频网。PLM之家科技,承接二次开发,视频定制,实施培训等业务。www.plmhome.com; && www.plmhome.net-->欢迎联系我们--QQ 939801026
    回复

    使用道具 举报

  • TA的每日心情

    2017-5-26 12:10
  • 签到天数: 9 天

    [LV.3]偶尔看看II

    301

    主题

    610

    帖子

    7000

    积分

    管理员

    PLM之家NX|TC专家

    Rank: 9Rank: 9Rank: 9

    积分
    7000
     楼主| 发表于 2013-12-2 20:43:58 | 显示全部楼层
    PLM之家-NX9.0二次开发实例 24 创建自定义基准CSYS控件使用(1)block UI创建
    PLM之家,专业的NX,Teamcenter学习视频网。PLM之家科技,承接二次开发,视频定制,实施培训等业务。www.plmhome.com; && www.plmhome.net-->欢迎联系我们--QQ 939801026
    回复 支持 反对

    使用道具 举报

  • TA的每日心情

    昨天 13:24
  • 签到天数: 52 天

    [LV.5]常住居民I

    1683

    主题

    3250

    帖子

    5万

    积分

    管理员

    PLM之家mildcat

    Rank: 9Rank: 9Rank: 9

    积分
    54546
    发表于 前天 15:24 | 显示全部楼层
    PLM之家-NX9.0二次开发实例 24 创建自定义基准CSYS控件使用(2)项目创建




    PLM之家,专业的NX,Teamcenter学习视频网。PLM之家科技,承接二次开发,视频定制,实施培训等业务。www.plmhome.com; && www.plmhome.net-->-->点团信息科技-->-->欢迎联系我们--QQ 939801026
    回复 支持 反对

    使用道具 举报

  • TA的每日心情

    昨天 13:24
  • 签到天数: 52 天

    [LV.5]常住居民I

    1683

    主题

    3250

    帖子

    5万

    积分

    管理员

    PLM之家mildcat

    Rank: 9Rank: 9Rank: 9

    积分
    54546
    发表于 前天 15:25 | 显示全部楼层
    PLM之家-NX9.0二次开发实例 24 创建自定义基准CSYS控件使用(3)获取CSYS信息


    PLM之家,专业的NX,Teamcenter学习视频网。PLM之家科技,承接二次开发,视频定制,实施培训等业务。www.plmhome.com; && www.plmhome.net-->-->点团信息科技-->-->欢迎联系我们--QQ 939801026
    回复 支持 反对

    使用道具 举报

  • TA的每日心情

    昨天 13:24
  • 签到天数: 52 天

    [LV.5]常住居民I

    1683

    主题

    3250

    帖子

    5万

    积分

    管理员

    PLM之家mildcat

    Rank: 9Rank: 9Rank: 9

    积分
    54546
    发表于 前天 15:27 | 显示全部楼层
    PLM之家-NX9.0二次开发实例 24 创建自定义基准CSYS控件使用(4)创建csys对象



    PLM之家,专业的NX,Teamcenter学习视频网。PLM之家科技,承接二次开发,视频定制,实施培训等业务。www.plmhome.com; && www.plmhome.net-->-->点团信息科技-->-->欢迎联系我们--QQ 939801026
    回复 支持 反对

    使用道具 举报

  • TA的每日心情

    昨天 13:24
  • 签到天数: 52 天

    [LV.5]常住居民I

    1683

    主题

    3250

    帖子

    5万

    积分

    管理员

    PLM之家mildcat

    Rank: 9Rank: 9Rank: 9

    积分
    54546
    发表于 前天 15:27 | 显示全部楼层
    PLM之家-NX9.0二次开发实例 24 创建自定义基准CSYS控件使用(5)更改CSYS对象颜色

    PLM之家,专业的NX,Teamcenter学习视频网。PLM之家科技,承接二次开发,视频定制,实施培训等业务。www.plmhome.com; && www.plmhome.net-->-->点团信息科技-->-->欢迎联系我们--QQ 939801026
    回复 支持 反对

    使用道具 举报

    该用户从未签到

    0

    主题

    74

    帖子

    269

    积分

    中级会员

    Rank: 3Rank: 3

    积分
    269
    发表于 2013-12-8 15:37:44 | 显示全部楼层
    楼主好厉害.
    回复 支持 反对

    使用道具 举报

    该用户从未签到

    0

    主题

    16

    帖子

    44

    积分

    新手上路

    Rank: 1

    积分
    44
    发表于 2013-12-15 11:33:02 | 显示全部楼层
    22232ddddd
    回复 支持 反对

    使用道具 举报

    该用户从未签到

    0

    主题

    22

    帖子

    56

    积分

    注册会员

    Rank: 2

    积分
    56
    发表于 2013-12-23 12:17:57 | 显示全部楼层
    dsfsgsdgsdg
    回复 支持 反对

    使用道具 举报

    该用户从未签到

    13

    主题

    129

    帖子

    467

    积分

    中级会员

    Rank: 3Rank: 3

    积分
    467
    发表于 2013-12-28 12:02:42 | 显示全部楼层
    相当给力,顶一个
    回复 支持 反对

    使用道具 举报

    您需要登录后才可以回帖 登录 | QQ关联注册

    本版积分规则

    关闭

    站长推荐 上一条 /1 下一条

    <

    QQ|小黑屋|手机版|Archiver|PLM之家-NX|Catia|Teamcenter|Tecnomatix数字化软件学习网 ( 沪ICP备13003373-3

    GMT+8, 2017-10-17 10:00 , Processed in 0.156411 second(s), 40 queries .

    Powered by PLM之家科技! X3.2

    © 2001-2013 PLMHome Inc.

    快速回复 返回顶部 返回列表